/*==================================================================
=  ļ  : Lex
=  Ҫ: ʷ
=  ޸: 2006.10
=      : shen beide
====================================================================*/

#if !defined(_LEX_H)
#define _LEX_H

#include "PubHeader.h"
#include "Lexbase.h"
#include "ObArray.h"
#include "StringObject.h"

/*
#define _LEX_DEBUG_ON_
*/

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
// ˵: ַ()SubRULE + ظ 
//               
// \.  	 ƥзκַ.ַ[^\n\r](Window)[^\n]( Unix)ļд
// \b    ƥһʵĿʼβ   ƥһʱ߽磬ҲָʺͿոλá
// ^ 	 ƥַĿʼ           ΪƥʱƥеĿʼ '\r\n''\n'
// $ 	 ƥַĽβ         ΪƥʱƥеĽ
// \d 	 κ
// \c    ĸ([a-zA-Z]) 
//
// *     ظ            
// +     ظһλ 
// ?     ظһλ0 
// <n>   ظn 
// <n,m> ظnΣm 
// <n,>  ظn 
//
// ( )   
// [ ]   Χ֮, ַ(ֱ֧׼256ASCIIַ), ]\͵һַ^$, ַҪת
// [^]	 Χ֮, ]\ַ֮Ҫת
// |     ѡ()
//
// {name}     Ѷ
// {name Id}  Ѷ, ƥ䴮TokenеParamList[Id]
//            δԶParamId,ϵͳĬϻὫӷð˳򷵻      
//
// {?[ ]}     Χ֮ڵַǰʱֹͣ(Χͬ), , ö岻֧ظ(ΪȻΪѭ)
// {?=str}    strǰֹͣ, ö岻֧ظ(ΪȻΪѭ), str
// {?>str}    strֹͣ, ö岻֧ظ, str
//            ģʽ,Чٵݹ֧Ŀ,ٶ
//
//
// ע: 1. ^$*+?<[()|{} Ǿ⺬ַ, 
//                     
//                     Ҫʹԭʼ,Ҫַǰת\\
//
//        [ ] гַΪ^(ʾǰ), ϵ⺬ַپ, -(){}Ҫ\\
//            Ժ\\d \\c \\. ʾһ
//
//     2. *+?<>ظ, ټ?, ʾ̰ģʽ(ظ)
//
////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////
#ifdef _DLL_PROJECT
template class CLASS_EXPORT TObArray<LexState>;
template class CLASS_EXPORT CObjectPool_<MatchPattern>;
template class CLASS_EXPORT TObArray<MatchPattern>;  
#endif

//////////////////////////////////////////////////////////////
#ifdef _DLL_PROJECT
class CLASS_EXPORT LexRules
#else
class LexRules
#endif
{
public:
    LexRules();
   ~LexRules();
    
    bool AddRule(long Id, char* szRule);
    bool AddRule(long Id, char* szRuleName, char* szRule);
    int  GetRuleNum();

    LexState* FoundRule(long  Id);
    LexState* FoundRule(char* szName,long* pId=NULL);
    
    bool Optimize();
    
    bool Dump(char* filename,bool bOverWrite=true);
    bool DumpRule(long Id,OTSTR& strRule);

    void Clear();

    OTSTR& GetLastError() { return m_strLastError;  }
    
private:
    LexState* BuildRule(long Id, char* szRule);
    LexState* NewLexState();

    CharSet*  GetCharSet(char* &szRule);
    RepeatAttribute* GetRepeatAttribute(char* &szRule);
    char GetChar(const char*& pFrom,bool& bIsEscape);
    long GetLong(const char*& pFrom);
        
    bool DumpRule (LexState* pEntry, OTSTR& strRule);
    bool CheckRule(LexState* pEntry, bool ParamList[]);
        
private:    
    friend class LexState;
    friend class CLex;

    /////////////////////////////////////////
    TObArray<LexState>  m_RuleEntryList;
    TObArray<LexState>  m_StateObjectList;  // ɾ
    
    bool                m_bHasCustomReturnParam;
    bool                m_bEnableLineBoundCheck;      
    bool                m_bEnableWordBoundCheck;      
    
    OTSTR    m_strLastError;
};

//////////////////////////////////////////////////////////////
#ifdef _DLL_PROJECT
class CLASS_EXPORT LexToken: public TObject
#else
class LexToken: public TObject
#endif
{
public:
    enum { TOKEN_INVALID=-1, TOKEN_UNMATCH=0 };  // system Reserved TokenId

private:
    long     m_TokenId;     // RuleId
    OTSTR 	 m_TokenName;
    Location m_TokenLocation;
    long     m_TokenLen;

    int      m_ParamNum;
    long     m_ParamLocatList[MAX_LEXPARAM_ID+1][2];   // [2] begin(λ),len   initial: -1,-1
    
public:
    LexToken();
    LexToken(long TokenId,char* name,long namelen=-1);

    ////////////////////////////////////////////////
    long      getTokenId()  { return m_TokenId; }
    OTSTR&    getName()     { return m_TokenName;  }
    Location& getLocation() { return m_TokenLocation; }
    long      getTokenLen() { return m_TokenLen;  }
    int       getParamNum() { return m_ParamNum;  }
    bool      getParam(long ParamId, OTSTR& strRet);
    
    bool isToken(long TokenId) { return (m_TokenId==TokenId)? true:false; }
    
    void set(long TokenId,char* name, long namelen=-1);
    void setTokenId(long TokenId);
    void setLocation(long locat,long nline,long ncolumn=-1);
    void setLocation(Location& locat);
    void setTokenLen(long len);

    void operator=(const LexToken& right);
    void clone(const LexToken& right);
    
protected:
    friend class CLex;
};

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
#ifdef _DLL_PROJECT
class CLASS_EXPORT CLex
#else
class CLex
#endif
{
public:
    enum { UNRETURN_RULE_BEGIN_ID=1000, //GetTokenʱΪToken, ϷToken, 
           INTERNAL_RULE_BEGIN_ID=2000  //ڲ(̵),Ϊʷ
    };   

    enum { GET_TOKEN_EOF=0, GET_TOKEN_SUCC=1, GET_TOKEN_FAIL=-1 };

public:
    CLex();
    virtual ~CLex();

    virtual char* GetName() { return ""; }
    virtual char* GetPath() { return ""; }
    virtual char* GetAbsoluteFilename() { return ""; }
    
    void  setRules(LexRules* pLexRules);
    bool  FoundRule(long  Id);
    bool  FoundRule(char* szName,long* pId=NULL);
    
    void  Enable_OverlapMatch(bool bEnableOverlapMatch=true);    // ÿGetTokenMatchPatternList
    void  Enable_ReturnUnMatchedContent(bool bReturnUnMatchedContent=true);  // match and unmatch(TokenType=Other)
    void  Enable_CaseSensitive(bool bCaseSensitive=true);
    void  SetWordBoundMode(int mode);  //  mode=0  (0x20 <ch< 0x7F)ַĽΪWordbound
                                       //      =1  (0x00<=ch<=0x20)ַĽΪWordbound,ʶ

    void  setLocatOffset(Location& locat);
    Location& getLocatOffset();
    
    void  setBuffer(char* pbuf, long buflen=-1);
    char* getBuffer() { return m_pbuf;   }
    long  getBufLen() { return m_buflen; }

    virtual void Reset(bool bResetBuffer);
    
    /////////////////////////////////////////////////////////////////////
    // Params: bJustPreview=false  Get & move out next Token
    //         bJustPreview=true   Just read next Token (not move out)
    virtual int  GetToken(LexToken& Token, bool bJustPreview=false);   
    virtual int  GetToken(LexToken& Token, WORD nExFlag, bool bJustPreview);
    virtual bool GetSpecificToken(LexToken& Token, long TokenId); // 0<TokenId
    
    bool  Fetch_string(char* szLeftOperator, char* szRightOperator, bool bStartWithLeftOperator, // Ե() [], ǰbufLeftOperatorͷ
                       bool bReturnBetween, OTSTR& strReturn);  // bReturnBetweenشǷLeft & Right Operator
                                                                // bStartWithLeftOperatorֻеszLeftOperator!=NULLʱЧ
    bool  ForwardLocatTo(long nLocat);

    virtual Location& getLocation() { return m_location; }
    virtual bool  setLocation(Location& locat);

    OTSTR& GetLastError()   { return m_strLastError;  }
    
private:
    int   GetToken_(LexToken& Token, long RuleId, bool bJustPreview);   

    bool  TryFrom(Location& Locat, long RuleId=-1); // 
    bool  PriTryFrom(Location& Locat);              // 
    bool  InputChar (long nCurLocat,short eChar,bool& bContinue);
    bool  Transition(long nCurLocat,short eChar,bool bCaseSensitive=true,short eCharReverse=0);

    void  DumpStack(char* filename,bool bOverWrite=true);
    
    bool  isWordBound(unsigned char charLeft,unsigned char charRight);
    short CharReverse(short eChar);

    void  Clear_MatchPatternList(TObArray<MatchPattern>& PatternList);

    void  CreateTokenFromPattern(MatchPattern& Pattern, LexToken& Token);

    ////////////////////////////////////////////
    CObjectPool_<MatchPattern>  m_MatchPatternPool;
    
    MatchPattern* New_MatchPattern(MatchPattern* pClonePattern=NULL);
    void  Delete_MatchPattern(MatchPattern* pPattern);
    
protected:
    enum { CHECK_TOP_STATE=300 };
    
    char*     m_pbuf;
    long      m_buflen;
    Location  m_location;
    
    LexRules* m_pLexRules;
    bool      m_bUserOptimizedMode;
    bool      m_bReturnUnMatchedContent;    // default: true
    bool      m_bEnableOverlapMatch;        // default: false
    bool      m_bCaseSensitive;             // default: true
    int       m_nWordBoundCheckMode;        // default: 1
    Location  m_locationOffset;

    OTSTR     m_strLastError;
    
    TObArray<MatchPattern>  m_MatchPatternList;  

    //////////////////////////////////
    friend class GramParser;
};

/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
#ifdef _DLL_PROJECT
class CLASS_EXPORT LexPattern
#else
class LexPattern
#endif
{
public:
    LexPattern(char* szRule=NULL);
   ~LexPattern();

    bool AddRule(bool bMainAccess,char* szRule);  // bMainAccessڻǷ(ڲRule)
    bool AddRule(bool bMainAccess,char* szRuleName,char* szRule);
    void Clear();

    void Enable_CaseSensitive(bool bCaseSensitive) { m_bCaseSensitive=bCaseSensitive; }
    
    bool Matching(char* szString,OtstrArray* lpParamArray=NULL);

    OTSTR& GetLastError() { return m_strLastError;  }
    
protected:
    LexRules m_Rules;
    CLex     m_Lex;
    bool     m_bCaseSensitive;      // default: true
    
    OTSTR    m_strLastError;
    
private:
    long     m_InternalRuleCounter;
};


#endif


